import { Tree as MemoryTree } from "@canvas-js/okra-memory";
import { ModelDB, ModelDBProxy } from "@canvas-js/modeldb-durable-objects";
import { Unstable_DevWorker } from "wrangler";
import { SqlStorage } from "@cloudflare/workers-types";
import { AbstractGossipLog, GossipLogInit } from "../AbstractGossipLog.js";
export declare class GossipLog<Payload> extends AbstractGossipLog<Payload> {
    readonly db: ModelDB | ModelDBProxy;
    readonly tree: MemoryTree;
    static open<Payload>({ db, worker, useTestProxy, clear, ...init }: {
        db?: SqlStorage;
        worker?: Unstable_DevWorker;
        useTestProxy?: boolean;
        clear?: boolean;
    } & GossipLogInit<Payload>): Promise<GossipLog<Payload>>;
    private constructor();
}
