import { Stream } from "@libp2p/interface";
import { Logger } from "@libp2p/logger";
import { Pushable } from "it-pushable";
import { Duplex } from "it-stream-types";
import { Uint8ArrayList } from "uint8arraylist";
import * as Sync from "@canvas-js/gossiplog/protocols/sync";
import { SyncSnapshot } from "../interface.js";
export declare function encodeResponses(responses: AsyncIterable<Sync.Response>): AsyncIterable<Uint8Array>;
export declare function decodeRequests(requests: AsyncIterable<Uint8ArrayList | Uint8Array>): AsyncIterable<Sync.Request>;
export declare class Server implements Duplex<Pushable<Sync.Response>, AsyncIterable<Sync.Request>> {
    #private;
    private readonly txn;
    static timeout: number;
    static handleStream(txn: SyncSnapshot, stream: Stream): Promise<void>;
    readonly source: Pushable<Sync.Response, void, unknown>;
    readonly log: Logger;
    private constructor();
    abort(): void;
    sink: (reqs: AsyncIterable<Sync.Request>) => Promise<void>;
    private handleRequest;
}
